glibmm: Gio::DBus::AuthObserver Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DBus::AuthObserver Class Reference
D-Bus API

AuthObserver - An object used for authenticating connections. More...

`#include <giomm/dbusauthobserver.h>`

Inheritance diagram for Gio::DBus::AuthObserver:
[legend]

## Public Member Functions
virtual | ~AuthObserver ()
GDBusAuthObserver* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusAuthObserver* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusAuthObserver* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | authorize_authenticated_peer (const Glib::RefPtr< const IOStream >& stream, const Glib::RefPtr< const Credentials >& credentials)
| Emits the DBusAuthObserver::signal_authorize_authenticated_peer() signal on observer. More...
bool | allow_mechanism (const std::string& mechanism)
| Emits the DBusAuthObserver::signal_allow_mechanism() signal on observer. More...
Glib::SignalProxy2< bool, const Glib::RefPtr< const IOStream >&, const Glib::RefPtr< const Credentials >& > | signal_authorize_authenticated_peer ()
Glib::SignalProxy1< bool, const std::string& > | signal_allow_mechanism ()
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< AuthObserver > | create ()

## Protected Member Functions
| AuthObserver ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::DBus::AuthObserver > | wrap (GDBusAuthObserver* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

AuthObserver - An object used for authenticating connections.

The AuthObserver type provides a mechanism for participating in how a Server (or a Connection) authenticates remote peers. Simply instantiate an AuthObserver and connect to the signals you are interested in. Note that new signals may be added in the future.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::DBus::AuthObserver::~AuthObserver | ( |  | ) |
| virtual

Gio::DBus::AuthObserver::AuthObserver | ( |  | ) |
| protected

## Member Function Documentation

bool Gio::DBus::AuthObserver::allow_mechanism | ( | const std::string & | mechanism | ) |

Emits the DBusAuthObserver::signal_allow_mechanism() signal on observer.

Since glibmm 2.34:

Parameters

  mechanism | The name of the mechanism, e.g. `DBUS_COOKIE_SHA1`.

Returns
  `true` if mechanism can be used to authenticate the other peer, `false` if not.

bool Gio::DBus::AuthObserver::authorize_authenticated_peer | ( | const Glib::RefPtr< const IOStream >& | stream,
|  | const Glib::RefPtr< const Credentials >& | credentials
| ) |  |

Emits the DBusAuthObserver::signal_authorize_authenticated_peer() signal on observer.

Since glibmm 2.26:

Parameters

  stream | A IOStream for the DBusConnection.
  credentials | Credentials received from the peer or `0`.

Returns
  `true` if the peer is authorized, `false` if not.

static Glib::RefPtr<AuthObserver> Gio::DBus::AuthObserver::create | ( |  | ) |
| static

static GType Gio::DBus::AuthObserver::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GDBusAuthObserver* Gio::DBus::AuthObserver::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GDBusAuthObserver* Gio::DBus::AuthObserver::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GDBusAuthObserver* Gio::DBus::AuthObserver::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::SignalProxy1< bool,const std::string& > Gio::DBus::AuthObserver::signal_allow_mechanism | ( |  | ) |

Slot Prototype:
  `bool on_my_allow_mechanism(const std::string& mechanism)`

Emitted to check if mechanism is allowed to be used.

Since glibmm 2.34:

Parameters

  mechanism | The name of the mechanism, e.g. `DBUS_COOKIE_SHA1`.

Returns
  `true` if mechanism can be used to authenticate the other peer, `false` if not.

Glib::SignalProxy2< bool,const Glib::RefPtr<const IOStream>&,const Glib::RefPtr<const Credentials>& > Gio::DBus::AuthObserver::signal_authorize_authenticated_peer | ( |  | ) |

Slot Prototype:
  `bool on_my_authorize_authenticated_peer(const Glib::RefPtr<const IOStream>& stream, const Glib::RefPtr<const Credentials>& credentials)`

Emitted to check if a peer that is successfully authenticated is authorized.

Since glibmm 2.26:

Parameters

  stream | A IOStream for the DBusConnection.
  credentials | Credentials received from the peer or `0`.

Returns
  `true` if the peer is authorized, `false` if not.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::AuthObserver > wrap | ( | GDBusAuthObserver * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.